Index: Fl_BMP_Image.cxx
===================================================================
--- Fl_BMP_Image.cxx	(revision 4297)
+++ Fl_BMP_Image.cxx	(working copy)
@@ -78,7 +78,8 @@
 		repcount,	// Number of times to repeat
 		temp,		// Temporary color
 		align,		// Alignment bytes
-		dataSize;	// number of bytes in image data set
+		dataSize,	// number of bytes in image data set
+		row_order = 1;	// 1 = normal;  -1 = flipped row order
   long		offbits;	// Offset to image data
   uchar		bit,		// Bit in image
 		byte;		// Byte in image
@@ -120,7 +121,10 @@
   } else {
     // New BMP header...
     w(read_long(fp));
-    h(read_long(fp));
+    // If the height is negative, the row order is flipped
+    temp = read_long(fp);
+    if (temp < 0) row_order = -1;
+    h(abs(temp));
     read_word(fp);
     depth = read_word(fp);
     compression = read_dword(fp);
@@ -184,7 +188,7 @@
   byte  = 0;
   temp  = 0;
 
-  for (y = h() - 1; y >= 0; y --) {
+  for (y = (row_order==1)?(h() - 1):0; (row_order==1)?(y >= 0):(y < h()); y -= row_order ) {
     ptr = (uchar *)array + y * w() * d();
 
     switch (depth)
